(load "D:/aclmidi/cormanmidi.lisp")

(defun encode (pitches &optional (ontime 0) (duration 100))
  (mapcar
     #'(lambda (p)
        (prog1
          (list (round ontime) p (round duration) 1 127)
          (incf ontime duration)))
    pitches))

(defun carest (tree)
  (if (atom tree)
    tree
    (carest (car tree))))

(defun render (pattern steps)
  (if (atom pattern)
    (loop for i from 1 to steps collect pattern)
    (if (= steps 1)
      (list (carest pattern))
      (mapcan #'(lambda (subpattern) (render subpattern (floor (/ steps (length pattern))))) pattern))))

(defun scale-black (&optional (root 61))
  (mapcar
    #'(lambda (offset) (+ root offset))
    '(0 2 5 7 9)))

(defun scale-note (scale index)
  (+ (* 12 (floor (/ index (length scale)))) (nth (mod index (length scale)) scale)))

(defun ms (index) (scale-note (scale-black 55) index))

(defun rand-tree (parent depth)
  (if (zerop (random depth))
    (+ parent (- (random 3) 1))
    (list (rand-tree parent (- depth 1))
            (rand-tree (+ parent (- (random 5) 2)) (- depth 1)) )))

(let ((alt1 't) (alt2 nil))
  (defun broadify (event)
    (setf alt1 (not alt1))
    (if alt1 (setf alt2 (not alt2)))
    
    (if (zerop (random 4)) (incf (second event) 12))
    (if alt1 (incf (second event) 12))
    (if alt2 (incf (second event) 12))
      
    event))


(progn  
  (setf pants  (transpose -24  (change-tempo 16 (encode (mapcar #'ms (render (rand-tree 0 8)      32) ) ))))
  (setf skorts (transpose 0 (change-tempo 4 (encode (mapcar #'ms (render (rand-tree 0 8)      128) ) ))))

  (play-dev-events 2 (mapcar #'broadify (append pants skorts)))   )

